'use strict'


class Cli
  constructor:(args) ->
    processArgs = process.argv.slice()
    processArgs.shift()
    processArgs.shift()
    @arguments = args ? processArgs

  getArgumentCount: ->
    @arguments.length   

  hasArguments: ->
    @arguments.length>0

  contains:(value, useExplicitMatch=false) ->
    expression = (x,y) -> x is y || x.indexOf(y) > -1
    if useExplicitMatch
      expression = (x,y) -> x is y

    found = @arguments.filter (x) -> expression x,value
    found.length>0

  getArgumentAt:(index) ->
    if index < 0 or index > @arguments.length-1
      throw new Error('Index out of range')
    @arguments[index]

  getArgumentValue:(key, delimiter ='=') ->
    results = @arguments.filter (x) -> x.indexOf("#{key}#{delimiter}") is 0
    values = results[0].split(delimiter)
    values[1] ? ''

root = exports ? window
root.Cli = Cli